# The Zero Bugs Commitment

This project adheres to the **Zero Bugs Commitment** (`#ZeroBugs`).
This is a commitment to practice *responsible software engineering*,
*proactive community participation*, and *positive community engagement*,
with a goal of keeping the count of known or open bugs at zero, while
respecting and cultivating contributions.

**As developers of this project, we pledge that:**

## (1) We will prioritize fixing bugs over implementing new features.

*(Motivation: It is human nature to be much more interested in building new
things than doing the hard work to fix old, broken things.)*

💡 We pledge, wherever reasonable, to prioritize fixing known bugs above
implementing new features, with the goal of **keeping the count of known or
open bugs at zero**.

## (2) We will take responsibility for code we have written or contributed to.

*(Motivation: As attention shifts between projects, it is difficult to return
to work on old code. This can lead to bit rot.)*

💡 We pledge to take long-term responsibility for any significant code we
create or contribute to, fixing problems and updating code as necessary to
prevent bit rot. If we can no longer fulfill this responsibility, we will
find someone else who can assume the responsibility for our code.

Note that this is about taking *personal responsibility* for our own work, not
about who has *official maintainership* for a project or piece of code.

## (3) We will be responsive during the bugfixing process.

*(Motivation: It is easy to delay responding to a bug report, a bug comment or
a request until the issue becomes forgotten or obsolete. This is the unfortunate
end state of a significant proportion of bug reports filed across the open
source ecosystem.)* 

💡 We pledge to be responsive to bug reports, comments and requests currently
open in our project's bug tracker, and to be proactive in resolving problems
as quickly as practical.

## (4) We will be respectful and inclusive.

*(Motivation: Open source communities have been known to reject halting but
earnest efforts of new contributors. Bug trackers are also full of pet
complaints and bugs closed as `#WONTFIX`, without a significant attempt to
understand core issues, or to find a solution or compromise.)*

💡 We pledge to cultivate contributions and growth in our community by
welcoming, encouraging, and helping users who offer contributions;
by striving to listen to the needs and requests of community members;
and by trying to find a reasonable solution or middle ground when there is
a disagreement.

---

**THIS DOCUMENT IS IN THE PUBLIC DOMAIN**

You are strongly encouraged to share this commitment, to make this commitment
yourself for software that you develop or maintain, and to encourage others to
do the same.

**To sign this pledge**, you can add the following wording to your project
homepage, linking to this document, or to your own copy or your own version of
this document:

| **This project adheres to the [Zero Bugs Commitment](https://github.com/classgraph/classgraph/blob/master/Zero-Bugs-Commitment.md).** |
|-----------------------------|

You may modify or redistribute this document at will without restriction.
However, please leave a record of your changes below.

#### Version history:

0.1: Original version (author: Luke Hutchison)
